import 'dart:async';

import 'package:example/state/state.dart';
import 'package:osam/domain/store/store.dart';
import 'package:osam/osam.dart';
import 'package:osam/presentation/presenter.dart';

class ExamplePresenter extends Presenter<Store<AppState>> {
  String get initialData => store.state.counter;

  Stream<String> get stream => store.state.propertyStream((state) {
        return state.counter;
      });

  void increment() =>
      store.dispatchEvent(event: Event(reducer: (state) => state..counter = state.counter + '1'));

  @override
  void dispose() {
    // TODO: implement dispose
  }
}
